Attribute VB_Name = "modAdvent"
' **************************************'***************************************
' ** Startmodul binhaltet die vorzeitigen Abruch auerhalb vom Dezember       **
' **************************************'***************************************
Option Explicit

' API's fr Lesen/und Schreiben von INI-Dateien
Private Declare Function GetPrivateProfileString Lib _
  "kernel32" Alias "GetPrivateProfileStringA" ( _
  ByVal lpApplicationName As String, _
  ByVal lpKeyName As Any, _
  ByVal lpDefault As String, _
  ByVal lpReturnedString As String, _
  ByVal nSize As Long, _
  ByVal lpFileName As String) As Long

Private Declare Function WritePrivateProfileString Lib _
  "kernel32" Alias "WritePrivateProfileStringA" ( _
  ByVal lpApplicationName As String, _
  ByVal lpKeyName As Any, _
  ByVal lpString As Any, _
  ByVal lpFileName As String) As Long

' GetUserName-Funktion
Private Declare Function API_GetUserName Lib _
  "advapi32.dll" Alias "GetUserNameA" ( _
  ByVal lpBuffer As String, nSize As Long) As Long

' INI-Datei
Public INIFileName As String

'zunchst die bentigten API-Deklarationen
Private Declare Function SendMessage Lib "user32" _
  Alias "SendMessageA" (ByVal hwnd As Long, _
  ByVal wMsg As Long, ByVal wParam As Long, _
  lParam As Long) As Long
Private Declare Function GetClientRect Lib "user32" _
  (ByVal hwnd As Long, lpRect As cRECT) As Long
Private Declare Function RedrawWindow Lib "user32" _
  (ByVal hwnd As Long, lprcUpdate As cRECT, _
  ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) _
  As Long

Private Const WM_SETREDRAW = &HB
Private Const RDW_INVALIDATE = &H1
Private Const RDW_ALLCHILDREN = &H80
Private Const RDW_UPDATENOW = &H100
Private Const RDW_ERASE = &H4

Private Type cRECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

' Bentigte API-Deklarationen
' kurzer Pfad(8.3) ermitteln
Private Declare Function GetShortPathName Lib "kernel32" _
  Alias "GetShortPathNameA" ( _
  ByVal lpszLongPath As String, _
  ByVal lpszShortPath As String, _
  ByVal cchBuffer As Long) As Long

' Sound, Video, infos, spielen u.s.w.
Private Declare Function mciSendString Lib "winmm.dll" _
  Alias "mciSendStringA" ( _
  ByVal lpstrCommand As String, _
  ByVal lpstrReturnString As String, _
  ByVal uReturnLength As Long, _
  ByVal hwndCallback As Long) As Long

Private Declare Function CallWindowProc Lib "user32" Alias _
        "CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
        ByVal hwnd As Long, ByVal msg As Long, ByVal wParam _
        As Long, ByVal lParam As Long) As Long

Private Declare Function SetWindowLong Lib "user32" Alias _
        "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex _
        As Long, ByVal dwNewLong As Long) As Long

Private Const MCI_NOTIFY& = &H3B9
Private Const MCI_NOTIFY_SUCCESS& = &H1
Private Const GWL_WNDPROC = -4

Private hPWnd As Long
Private hWndForm As Long

Private Datum As Date
Public Starten As Boolean

Public LiedNummer As Integer

Public Enum FileExistsReturn
    feDoesntExist = 0   ' Die Datei existiert nicht.
    feZeroLen = 1       ' Die Datei existiert, ist aber 0 Zeichen lang.
    feExists = 2        ' Die Datei existiert und ist lnger als 0.
End Enum

Sub Main()
' **************************************'***************************************
' ** Prozedur Name: Main                                                      **
' ** Datum:         14.12.2004                                                **
' ** Bemerkung:                                                               **
' **************************************'***************************************

On Error GoTo Fehler
    Datum = Date                        ' ermittelt das Datum

  If InStr(Command$, "/I") Then         ' Zum Installieren des Programms
    If Year(Datum) <> INILesen("Jahr", , "Allgemein", True) Then
                                        ' berprft ob die gespeicherten Angaben
                                        '  zum aktuellem Jahr passen.
      Call Advent_Berechnen             ' Berechnet den Kalender neu
    End If
    
    Call SetAutoRun("Adventkalender", App.Path & "\" & App.EXEName & ".exe")
                                        ' Stellt ein, das der Kalender bei jedem
                                        '  Windowsstart ausgefhrt wird.
    Starten = False                     ' Bentigt fr das aufrufen der
                                        '  Einstellung
    frmEinstellungen.Show 1             ' ffnet das Einstellungsfenster.
    If Starten = False Then End         ' Wurde in den Einstellungen auf Beenden
                                        '  geklickt
  End If
  
  If InStr(Command$, "/E") Then         ' Kommand fr das ffnen des
                                        '  Einstellungsfenster
    Starten = False                     ' Bentigt fr das aufrufen der
                                        '  Einstellung
    frmEinstellungen.Show 1             ' fnet das Einstellungsfenster.
    If Starten = False Then End         ' Wurde in den Einstellungen auf Beenden
                                        '  geklickt
  End If
    
  If Year(Datum) <> INILesen("Jahr", , "Allgemein", True) Then
                                        ' berprft ob das gespeicherte Jahr
                                        '  das aktuelle ist
    Call Advent_Berechnen               '  Berechnet den Kalender neu
  End If
  
  If Date = INILesen("1.Advent", , "Allgemein", True) And _
      Now < "1.12." & Year(Now) Then    ' Ist der aktuelle Tag der 1.Adventso
    MsgBox "Heute ist der erste Adventsonntag. Obwohl der Dezember noch " + _
        "nicht da ist," & Chr(13) & "beginnt schon die Weihnachtszeit und " + _
        "bald ist Weihnachten da." & Chr(13), vbInformation
                                        ' Gibt eine Meldung am 1.Advent aus
  End If
  If Date = "1.1." & Year(Date) Then    ' Ist der aktuelle Tag Neujahr
    MsgBox "HAPPY NEW YEAR", vbInformation
                                        ' Gibt eine Meldung zu Neujahr aus
  End If
    If App.PrevInstance Or Month(Now) < 12 Then
                                        ' Ist das Programm schon geffnet und
                                        '  das Monat ist nicht Dezember
      End                               '  dann wird das Programm beendet
    End If
    Load frmAdvent                      ' Ladet das Hauptfenster
    DoEvents                            '
    frmAdvent.Visible = True            ' Zeigt den Adventkalender an
    frmAdvent.Show                      '  ---

Exit Sub

Fehler:
  MsgBox "Es ist ein Fehler aufgetretten." & Chr(13) & Chr(13) & _
      Err.Description                   ' Fehlerausgabe
End Sub

Private Sub Advent_Berechnen()
' **************************************'***************************************
' ** Prozedur Name: Advent_Berechnen                                                      **
' ** Datum:         14.12.2004                                                **
' ** Bemerkung:                                                               **
' **************************************'***************************************

On Error GoTo Fehler                    ' Bei einem Fehler diesn ausgeben
Dim intWochentag As Integer             ' Beinhalten den Wochtag vom Heiligen
                                        '  Abenden
Dim intZ As Integer                     ' Zhlvariable

  If FileExists(App.Path & "\" & App.EXEName & ".INI") = feExists Then _
     Kill App.Path & "\" & App.EXEName & ".INI"
                                        ' Wenn die INI-Datei existiert wird
                                        '  diese gelscht
  Call INISchreiben("Jahr", Year(Datum), "Allgemein", True)
                                        ' Speichert das aktuelle Jahr in die INI
  For intZ = 1 To 24                    ' Durchluft jeden Tag
    Randomize                           ' startet den Zufallsgenerator
    Select Case intZ                    ' berprft den gewhlten Tag
    
                                        ' Die Fensterbilder werden per Zufall
                                        '  erzeugt und in die INI gespeichert
    Case 5: Call INISchreiben(5, "202" & Int(2 * Rnd + 1), "FernsterBild", True)
    Case 6: Call INISchreiben(6, "203" & Int(5 * Rnd + 1), "FernsterBild", True)
    Case 24: Call INISchreiben(24, "204" & Int(6 * Rnd + 1), "FernsterBild", _
            True)
    Case Else: Call INISchreiben(CStr(intZ), Int(39 * Rnd + 2051), _
            "FernsterBild", True)
    End Select
  Next intZ
  
  intWochentag = WeekDay("24.12." & Year(Datum)) - 1
                                        ' errechnet den Wochentag vom 24.12
                                        
                                        ' Berechnet die Fensterbilder der
                                        '  Adventsonntage per Zufall und
                                        '  speichert das Ergnist in die INI
  Call INISchreiben("4.Advent", (24 - intWochentag) & ".12." & Year(Date), _
      "Allgemein", True)
  Call INISchreiben(CStr(Day((24 - intWochentag) & ".12." & Year(Date))), _
      2014, "FernsterBild", True)
  Call INISchreiben("3.Advent", (24 - intWochentag) - 7 & ".12." & Year(Date), _
      "Allgemein", True)
  Call INISchreiben(CStr(Day((24 - intWochentag) - 7 & ".12." & Year(Date))), _
      2013, "FernsterBild", True)
  Call INISchreiben("2.Advent", (24 - intWochentag) - 14 & ".12." & Year(Date), _
      "Allgemein", True)
  Call INISchreiben(CStr(Day((24 - intWochentag) - 14 & ".12." & Year(Date))), _
      2012, "FernsterBild", True)
      
  If (24 - intWochentag) - 21 > 0 Then  ' Berechnet den 1.Adventsonntag.
                                        '  Befindet er sich im Dezember
    Call INISchreiben("1.Advent", (24 - intWochentag) - 21 & ".12." & _
        Year(Date), "Allgemein", True)
    Call INISchreiben(CStr(Day((24 - intWochentag) - 21 & ".12." & _
        Year(Date))), 2011, "FernsterBild", True)
  Else
    Call INISchreiben("1.Advent", 30 + (24 - intWochentag) - 21 & ".11." & _
        Year(Date), "Allgemein", True)
  End If
                                        
  Dim arrA() As Integer                 ' Enthlt alle mglichen Nummern
  Dim intA As Integer                   ' Enthlt das Element fr den Tag
  Dim intB As Integer                   ' die maximale Anzahl an Elementen
  
  ReDim arrA(37)                        ' Dimensioniert das Feld, die gre
                                        '  ergibt sich aus der Ressource
  For intZ = 0 To 37                    ' Durchluft das ganze Feld
    arrA(intZ) = intZ + 3000            ' Flt das Feld mit den Werten
  Next intZ
  
  intB = UBound(arrA)                   ' ermittelt die Gre des Feldes
  For intZ = 1 To 22                    ' Durchluft alle Tage auer sonderflle
    If intZ = 4 Or intZ = 5 Or intZ = 6 Then
                                        ' Bei den Sonderfllen den Zeiger um 1
      intZ = intZ + 1                   '  erhhen
    Else
      Randomize                         ' Startet den Zufallsgenerator
      intA = intB * Rnd                 ' Erzeugt per Zufall die Nummer des
                                        '  Elements, welches gespeichert wird
      Call INISchreiben(CStr(intZ), CStr(arrA(intA)), "Texte", True)
                                        ' Speichert den Wert aus dem Feld als
                                        '  Nr. fr einen Text ab
      MoveInList arrA, intA, UBound(arrA)
                                        ' Bewegt den Eintrag ans Ende
      ReDim Preserve arrA(UBound(arrA) - 1)
                                        ' Verringert das Feld um eins und lscht
                                        '  den aktuellen Eintrag
      intB = intB - 1                   ' Veringert die Berechnete Gre des Feldes
    End If
  Next intZ
  
                                        ' Berechnen der Texte und abspeichern in
                                        '  die INI
  Call INISchreiben(4, 3050, "Texte", True)
  Call INISchreiben(5, 3051, "Texte", True)
  Call INISchreiben(6, Int(2 * Rnd + 3052), "Texte", True)
  Call INISchreiben(23, Int(2 * Rnd + 3054), "Texte", True)
  Call INISchreiben(24, 3056, "Texte", True)

Exit Sub

Fehler:
MsgBox "Es ist bei der Berechnung der Adventdaten aufgetretten." & Chr(13) _
    & Chr(13) & "Fehler: " & Err.Description
                                        ' Ausgabe des Fehlers
End Sub

Public Function GetUserName() As String
' **************************************'***************************************
' ** Prozedur Name: GetUserName                                               **
' ** Datum:         14.12.2004                                                **
' ** Bemerkung:     Gibt den Namen des aktuell angemeldeten Benutzers zurck  **
' **************************************'***************************************

  GetUserName = String(100, Chr$(0))    ' Erstelle einen Puffer
  API_GetUserName GetUserName, 100      ' Ermittelt den Usernamen
  
  GetUserName = Left$(GetUserName, _
    InStr(GetUserName, Chr$(0)) - 1)    ' Lscht die berzhligen zeichen
End Function

' Liest Informationen aus INI-Dateien
' Key = Schlssel
' Paragraph = Abschnitt (Optional)
' PublicSetting = Gibt an ob die Einstellung fr alle
' Benutzer ist oder nur fr den aktuellen
Public Function INILesen(Key As String, _
  Optional DefaultValue As String = "", _
  Optional Paragraph As String = "Einstellungen", _
  Optional PublicSetting As Boolean = False) As String
  
  If PublicSetting Then
    ' globale Einstellung (alle User)
    Paragraph = "Public\" & Paragraph
  Else
    ' Userdefinierte Einstellung
    Paragraph = GetUserName & "\" & Paragraph
  End If
  
  If INIFileName = "" Then _
    INIFileName = App.Path & "\" & App.EXEName & ".INI"
  
  INILesen = String$(255, 0)
  If Key <> "" Then
    Call GetPrivateProfileString(Paragraph, Key, "", _
      INILesen, 255&, INIFileName)
  End If
  INILesen = Replace(INILesen, Chr(0), "")
  If INILesen = "" Then INILesen = DefaultValue

End Function

' Schreibt Informationen in INI-Dateien
' Key = Schlssel
' Value = Wert (Optional)
' Paragraph = Abschnitt (Optional)
' PublicSetting = Gibt an ob die Einstellung fr alle
' Benutzer ist oder nur fr den aktuellen
Public Sub INISchreiben(Key As String, _
  Optional Value As String = "", _
  Optional Paragraph As String = "Einstellungen", _
  Optional PublicSetting As Boolean = False)
  
  If PublicSetting Then
    ' globale Einstellung (alles User)
    Paragraph = "Public\" & Paragraph
  Else
    ' Userdefinierte Einstellung
    Paragraph = GetUserName & "\" & Paragraph
  End If
  
  If INIFileName = "" Then _
    INIFileName = App.Path & "\" & App.EXEName & ".INI"
  
  If Key <> "" Then
    WritePrivateProfileString Paragraph, Key, Value, _
      INIFileName
  End If
End Sub

Public Sub LockWindow(ByVal hwnd As Long, wLock As Boolean)
' **************************************'***************************************
' ** Prozedur Name: LockWindow                                                **
' ** Datum:         14.12.2004                                                **
' ** Bemerkung:                                                               **
' **************************************'***************************************

  Dim ClientRect As cRECT
  
  If wLock = True Then
    SendMessage hwnd, WM_SETREDRAW, False, 0&
  Else
    SendMessage hwnd, WM_SETREDRAW, True, 0&
    GetClientRect hwnd, ClientRect
    RedrawWindow hwnd, ClientRect, 0&, RDW_ERASE Or _
      RDW_INVALIDATE Or RDW_ALLCHILDREN Or RDW_UPDATENOW
  End If
End Sub

Public Sub Koordinaten(Tag As Integer, ByRef Left As Double, ByRef Top As Double)
' **************************************'***************************************
' ** Prozedur Name: Koordinaten                                               **
' ** Datum:         14.12.2004                                                **
' ** Bemerkung:     Festlegung der Kordinaten der einzelnen Fenster           **
' **************************************'***************************************

  Select Case Tag                       ' Durch Auswahl des Tages werden die
                                        '  Koordinaten zurckgegeben
  Case 1:  Left = 2880: Top = 1500
  Case 2:  Left = 600: Top = 2400
  Case 3:  Left = 6720: Top = 3960
  Case 4:  Left = 2040: Top = 4320
  Case 5:  Left = 3120: Top = 3960
  Case 6:  Left = 360: Top = 3840
  Case 7:  Left = 6480: Top = 1000
  Case 8:  Left = 3360: Top = 2280
  Case 9:  Left = 4560: Top = 1200
  Case 10: Left = 8280: Top = 240
  Case 11: Left = 1320: Top = 5280
  Case 12: Left = 4080: Top = 5640
  Case 13: Left = 7680: Top = 1680
  Case 14: Left = 7320: Top = 5160
  Case 15: Left = 8640: Top = 5640
  Case 16: Left = 4800: Top = 4440
  Case 17: Left = 6480: Top = 2760
  Case 18: Left = 4920: Top = 2160
  Case 19: Left = 1680: Top = 1200
  Case 20: Left = 240: Top = 5880
  Case 21: Left = 8160: Top = 4200
  Case 22: Left = 2040: Top = 2280
  Case 23: Left = 2760: Top = 5400
  Case 24: Left = 480: Top = 360
  End Select
  Left = Left / 9600
  Top = Top / 7200
End Sub

' Array-Element um x-Positionen nach vorne/hinten
' verschieben
Public Function MoveInList(vList As Variant, _
  ByVal nElement As Long, _
  ByVal nMove As Long)
  
  Dim i As Long
  Dim vTemp As Variant
  Dim nSize As Long
  Dim nMode As Integer
  
  ' Dimensionsgre
  nSize = UBound(vList)

  ' Plausibilittsprfungen
  If nElement + nMove < 0 Then
    nMove = nMove - (nMove + nElement)
  End If
  
  If nElement + nMove > nSize Then
    nMove = nSize - nElement
  End If
  
  ' Mode: nach hinten oder nach vorne verschieben?
  ' (Vorzeichen ermitteln)
  nMode = Sgn(nMove)
  
  ' Gltiger Wert?
  If nMode <> 0 Then
    ' zu verschiebendes Element "merken"
    vTemp = vList(nElement)

    ' Jetzt die einzelne Elemente verschieben
    For i = nElement + nMode To nElement + nMove Step nMode
      vList(i - nMode) = vList(i)
    Next i

    '  Element an die gewnschte Position setzen
    vList(nElement + nMove) = vTemp
  End If
End Function

' kurzer Pfad ermitteln (8.3)
Private Function Get_ShortFullPath( _
  ByVal FullPath As String) As String

  Dim Buffer As String

  Buffer = Space$(256)
  If GetShortPathName(FullPath, Buffer, Len(Buffer)) <> 0 Then
    Get_ShortFullPath = Left$(Buffer, _
      InStr(Buffer, vbNullChar) - 1)
  End If
End Function

' MIDI-Datei abspielen
Public Function MidiPlay(ByVal FullPath As String, hForm As Long) As Boolean
  Dim Buffer As String
  Dim ErrHandler As Long
  Dim ShortFullPath As String

  hWndForm = hForm
  hPWnd = SetWindowLong(hForm, GWL_WNDPROC, AddressOf chkMCI)
  
  ' Prfen ob eine MIDI-Datei bergeben wurde
  If UCase$(Mid$(FullPath, Len(FullPath) - 2)) <> "MID" Then
    MidiPlay = False: Exit Function
  End If
  
  ' Prfen ob der kurze pfad bergeben wurde
  ShortFullPath = Get_ShortFullPath(FullPath)
  If Len(ShortFullPath) = 0 Then
    MidiPlay = False: Exit Function
  End If
  
  Buffer = Space$(256)
  ErrHandler = mciSendString("open sequencer!" & _
    ShortFullPath & " alias MIDI", Buffer, Len(Buffer), 0)
  ErrHandler = mciSendString("play MIDI" & " notify", Buffer, _
    Len(Buffer), hWndForm)

  MidiPlay = (ErrHandler = 0)
End Function

' Abspielvorgang stoppen
Public Sub MidiStop()
  mciSendString "stop MIDI", 0, 0, 0
  mciSendString "close MIDI", 0, 0, 0
  Call SetWindowLong(hWndForm, GWL_WNDPROC, hPWnd)
End Sub

Function chkMCI(ByVal hwnd&, ByVal uMsg&, ByVal wParam&, ByVal _
                lParam&) As Long
  
  If uMsg = MCI_NOTIFY And wParam = MCI_NOTIFY_SUCCESS Then
    frmAdvent.tmSound.Interval = 100
  End If
  
  chkMCI = CallWindowProc(hPWnd, hwnd, uMsg, wParam, lParam)
End Function

Public Function FileExists( _
    ByRef strFileName As String _
    ) As FileExistsReturn
    On Error Resume Next
    
    ' Dateien knnen auch Lnge 0 haben und sie existieren.
    FileExists = feDoesntExist
    Select Case FileLen(strFileName)
        Case 0
            FileExists = feZeroLen
        Case Is > 0
            FileExists = feExists
    End Select
End Function
