VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.1#0"; "RICHTX32.OCX"
Begin VB.Form frmText 
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Weihnachtliches Allerlei"
   ClientHeight    =   6060
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8550
   Icon            =   "frmText.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6060
   ScaleWidth      =   8550
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ComboBox cmbDrucker 
      BackColor       =   &H0080FFC0&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   2400
      TabIndex        =   3
      Top             =   5520
      Width           =   3975
   End
   Begin VB.CommandButton cmdZurck 
      BackColor       =   &H00FF8080&
      Caption         =   "&Zurck"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      MaskColor       =   &H00FF8080&
      Style           =   1  'Grafisch
      TabIndex        =   2
      Top             =   5520
      Width           =   1935
   End
   Begin VB.CommandButton cmdDrucken 
      BackColor       =   &H0000C000&
      Caption         =   "&Drucken"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   6480
      Style           =   1  'Grafisch
      TabIndex        =   1
      Top             =   5520
      Width           =   1935
   End
   Begin RichTextLib.RichTextBox rtText 
      Height          =   5295
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   8295
      _ExtentX        =   14631
      _ExtentY        =   9340
      _Version        =   327681
      BackColor       =   14811105
      ReadOnly        =   -1  'True
      ScrollBars      =   3
      Appearance      =   0
      RightMargin     =   1
      AutoVerbMenu    =   -1  'True
      TextRTF         =   $"frmText.frx":08CA
   End
End
Attribute VB_Name = "frmText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' **************************************'***************************************
' ** Name:         frmText                                                    **
' ** Datum:        14.12.2004                                                 **
' ** Autor:        Gerhard Brandl                                             **
' ** Prozeduren:                                                              **
' ** Bemerkung:                                                               **
' **************************************'***************************************

Option Explicit

Dim LinkerRand As Long                  ' Beinhaltet die Rnder der RTF-Seiten
Dim ObererRand As Long                  '  beim Ausdruck
Dim RechterRand As Long
Dim UntererRand As Long

Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal _
        hDC As Long, ByVal nIndex As Long) As Long

Private Declare Function SendMessage Lib "user32" Alias _
        "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As _
        Long, ByVal wParam As Long, lParam As Any) As Long

Private Declare Function CreateDC Lib "gdi32" Alias _
        "CreateDCA" (ByVal lpDriverName As String, ByVal _
        lpDeviceName As String, ByVal lpOutput As Long, _
        ByVal lpInitData As Long) As Long

Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC _
        As Long) As Long

Private Const PHYSICALOFFSETX As Long = 112
Private Const PHYSICALOFFSETY As Long = 113
Private Const WM_USER As Long = &H400
Private Const EM_GETLINECOUNT As Long = &HBA
Private Const EM_LINEFROMCHAR As Long = &HC9
Private Const EM_FORMATRANGE As Long = WM_USER + 57
Private Const EM_SETTARGETDEVICE As Long = WM_USER + 72
Private Const EM_SCROLLCARET As Long = &HB7
Private Const EM_SCROLL As Long = &HB5
Private Const EM_LINESCROLL As Long = &HB6
Private Const EM_GETFIRSTVISIBLELINE As Long = &HCE
Private Const EM_LINELENGTH As Long = &HC1
Private Const EM_LINEINDEX As Long = &HBB

Private Type Rect
      Left As Long
      Top As Long
      Right As Long
      Bottom As Long
End Type

Private Type CharRange
  cpMin As Long
  cpMax As Long
End Type

Private Type FormatRange
  hDC As Long
  hdcTarget As Long
  rc As Rect
  rcPage As Rect
  chrg As CharRange
End Type

Private oResize As clsResize            ' Zum Anpassen der Steuerelemente an die
                                        '  Bildschirmausflsung.

Private Sub cmdDrucken_Click()
' **************************************'***************************************
' ** Prozedur Name: cmdDrucken_Click                                          **
' ** Datum:         14.12.2004                                                **
' ** Bemerkung:                                                               **
' **************************************'***************************************

Err.Number = 0                          ' Lscht alle Mglichen Fehler
Dim Prn As Printer

    ' Falls Combo1.Text = "" wurde kein Drucker ausgewhlt...
    If cmbDrucker.Text = "" Then
       MsgBox "Sie haben keinen Drucker ausgewhlt!", _
              vbInformation, "Error"
    Else
                                              
      For Each Prn In Printers          ' Durchluft jeden Drucker
        'Falls der vorhandene Drucker mit dem in der Combobox
        'augewhlten bereinstimmt, wird dieser als "Printer"
        'festgelegt (Set Printer = Prn ).
        If Prn.DeviceName = cmbDrucker.Text Then
          Set Printer = Prn
          Exit For
        End If
      Next

      If Err.Number = 0 Then            ' Wenn kein Fehler aufgetretten ist,
                                        '  wird der Text gedruckt
        Call PrintRTB(rtText, LinkerRand, _
            ObererRand, RechterRand, UntererRand)
                                        ' Druckt das RTF Dokument und fgt auch
                                        '  eine Fusszeile ein
      Else
        MsgBox "Bei der Druckerauswahl ist ein Fehler aufgedrehten.", _
            vbInformation               ' Der eingegebene Drucker wurde nicht
                                        '  gefunden
      End If
    End If
End Sub

Private Sub cmdZurck_Click()           ' Schliet das Fenster
  frmText.Tag = ""
  Unload Me
End Sub

Private Sub Form_Activate()
' *** GIF-Grafik anzeigen
Dim bGIF() As Byte
Dim sTempFile As String
                                        ' Positioniert das Fenster
 frmText.Top = frmAdvent.Top + (frmAdvent.Height / 100 * 10)
 frmText.Left = frmAdvent.Left + (frmAdvent.Width / 100 * 10)
 frmText.Height = frmAdvent.Height - (frmAdvent.Height / 100 * 20)
 frmText.Width = frmAdvent.Width - (frmAdvent.Width / 100 * 20)

                                        ' berprft die Uhrzeit und legt anhand
                                        '  dieser das Hintergrundbild fest
  If Time < #6:00:00 PM# And Time > #6:00:00 AM# Then
    Randomize                           ' Startet den Zufallsgenerator
    bGIF = LoadResData(2 * Rnd + 1000, "HINTERGRUND")
                                        ' Ladet das Hintergrundbild
  Else
    bGIF = LoadResData(1003, "HINTERGRUND")
                                        ' Ladet das Hintergrundbild
  End If
  
  sTempFile = resSaveDataTemp(bGIF())   ' Bild temporr speichern
  With frmText                          ' Das Hintergrundbild wird angepasst
    .AutoRedraw = True                  ' --- auf die grer der Form
    .PaintPicture LoadPicture(sTempFile), 0, 0, .Width, .Height
    .AutoRedraw = False
  End With
  Kill sTempFile                        ' Temporre Bilddatei lschen
  If Me.Tag > 25 Then                   ' Ladet den Text ins RTF-Feld
    rtText.TextRTF = LoadRTFFromRes(Me.Tag, "LiederText")
  Else
    rtText.TextRTF = LoadRTFFromRes(CInt(INILesen(Me.Tag, 3000, "Texte", True)))
  End If
End Sub

Private Sub Form_Load()
 
' **************************************'***************************************
 Set oResize = New clsResize            ' erstellt eine neue Instanz der Klasse
                                        ' zum Vergrer/verkleiner ohne Probleme
 oResize.oForm = frmText                ' Weist der Klasse die Form zu
 oResize.Initialize                     ' Startet die Klasse
 oResize.ResizeOption rtText, , False   ' startet das Anpassen an die Bildschirm
                                        '  gre
 
Dim BW&, BH&, r&
Dim TopOffSet As Long
Dim LeftOffSet As Long

  ObererRand = 1000                     ' Randeinstellungen des RTF-Ausdrucks
  LinkerRand = 1200                     '  Angaben in Twips
  RechterRand = 1000
  UntererRand = 1000
  
Dim x As Integer
Dim y As Integer
Dim Printername As String

    y = -1
    'Die Combobox mit vorhandenen Druckern fllen
    For x = 0 To Printers.Count - 1
      Printername = Printers(x).DeviceName
      cmbDrucker.AddItem Printername
      
      'Mit dem derzeit eingestellten vergleichen
      If Printername = Printer.DeviceName Then y = x
    Next x
    
    cmbDrucker.ListIndex = y


End Sub

Sub PrintRTB(RTF As RichTextBox, LeftMarginWidth As Long, _
             TopMarginHeight As Long, RightMarginWidth As Long, _
             BottomMarginHeight As Long)
On Error GoTo Fehler

Dim LeftOffSet As Long, TopOffSet As Long
Dim LeftMargin As Long, TopMargin As Long
Dim RightMargin As Long, BottomMargin As Long
Dim fr As FormatRange
Dim rcDrawTo As Rect
Dim rcPage As Rect
Dim TextLength As Long
Dim NextCharPosition As Long
Dim r As Long
Dim strHeader As String
Dim strFooter As String

    ' Kopf- und Fusszeile
    strFooter = "Frohe Weihnachten"

    'Initialisierung des Printers
    Printer.Print ""
    Printer.ScaleMode = vbTwips
    
    'Linken und Oberen Offset auslesen
    LeftOffSet = Printer.ScaleX(GetDeviceCaps(Printer.hDC, _
                                PHYSICALOFFSETX), vbPixels, _
                                vbTwips)
                                
    TopOffSet = Printer.ScaleY(GetDeviceCaps(Printer.hDC, _
                               PHYSICALOFFSETY), vbPixels, _
                               vbTwips)
   
    'Rnder berechnen
    LeftMargin = LeftMarginWidth - LeftOffSet
    TopMargin = TopMarginHeight - TopOffSet
    RightMargin = (Printer.ScaleWidth - RightMarginWidth) _
                   + LeftOffSet
                   
    BottomMargin = (Printer.ScaleHeight - BottomMarginHeight) _
                    + TopOffSet
    
    'Druckbarer Bereich in einer Variable speichern
    rcPage.Left = 0
    rcPage.Top = 0
    rcPage.Right = Printer.ScaleWidth
    rcPage.Bottom = Printer.ScaleHeight
    
    'Bereich in einer Veriable speichern, in dem gedruckt
    'werden soll
    rcDrawTo.Left = LeftMargin
    rcDrawTo.Top = TopMargin
    rcDrawTo.Right = RightMargin
    rcDrawTo.Bottom = BottomMargin
    
    'Druckerinstruktionen festlegen
    fr.hDC = Printer.hDC
    fr.hdcTarget = Printer.hDC
    fr.rc = rcDrawTo
    fr.rcPage = rcPage
    fr.chrg.cpMin = 0
    fr.chrg.cpMax = -1
    
    'Textlnge bestimmen
    TextLength = Len(RTF.Text)
    
    'Schriftgrsse/-art fr Kopf-/Fusszeilen
    Printer.Font = "Courier New" '"Arial"
    Printer.Fontsize = 11
       
    'Loop der alle Seiten ausdruckt
    Dim i As Integer:    i = 1
    Do
        'Text mit EM_FORMATRANGE ausdrucken
        NextCharPosition = SendMessage(RTF.hwnd, EM_FORMATRANGE, _
                                       1, fr)
        'Kopfzeile ausdrucken
        Printer.CurrentX = (Printer.ScaleWidth - _
                            Printer.TextWidth(strHeader)) / 2
                            
        Printer.CurrentY = (TopMargin - Printer.TextHeight("x")) _
                            / 2
                            
        Printer.Print strHeader
        'Fusszeile ausdrucken
        Printer.CurrentX = (Printer.ScaleWidth - _
                            Printer.TextWidth(strFooter)) / 2
                            
        Printer.CurrentY = BottomMargin + (Printer.ScaleHeight _
                           - BottomMargin - Printer.TextHeight("x")) _
                           / 2
                           
        Printer.Print strFooter
        'Seitennummer ausdrucken
        Printer.CurrentX = Printer.ScaleWidth - _
                           Printer.TextWidth("Seite " & i)
                           
        Printer.CurrentY = BottomMargin + (Printer.ScaleHeight - _
                           BottomMargin - Printer.TextHeight("x")) _
                           / 2
                           
        Printer.Print "Seite " & i
        'Falls alles ausgedruckt ist, Schleife verlassen
        If NextCharPosition >= TextLength Then Exit Do
        
        'Startposition fr die nchste Seite
        fr.chrg.cpMin = NextCharPosition
        'Neue Seite beginnen
        Printer.NewPage
        Printer.Print ""
        fr.hDC = Printer.hDC
        fr.hdcTarget = Printer.hDC
        i = i + 1
    Loop
    
    'Druckauftrag abschliessen
    Printer.EndDoc
    
    'Control zurcksetzten
    r = SendMessage(RTF.hwnd, EM_FORMATRANGE, 0, ByVal CLng(0))

Exit Sub

Fehler:
  MsgBox "Es ist ein Fehler beim Drucker aufgetretten." & Chr(13) & Chr(13) & _
       "berprfen Sie ob der Drucker eingeschaltetet ist" & Chr(13) & _
       "und ob eine Verbindung besteht!", vbInformation
End Sub


Private Sub Form_Resize()
' **************************************'***************************************
  oResize.DoResize                      ' Ruft die Anpassung der Form auf

End Sub
